#extension GL_OES_EGL_image_external : require

#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif

varying vec2 textureCoordinate;
uniform vec4 color;
uniform vec4 glassColor;
uniform float opacity;
uniform float hardness;
uniform float radius;

void main()
{
    float solidArea = radius * hardness;
    float d = distance(textureCoordinate, vec2(0.5, 0.5));
    if (d <= solidArea) {
        gl_FragColor = mix(glassColor, color, opacity);
    } else if (d <= radius) {
        float strength = (d - radius) / (solidArea - radius) * opacity;
        gl_FragColor = mix(glassColor, color, strength);
    } else {
        gl_FragColor = glassColor;
    }
}