#extension GL_OES_EGL_image_external : require

#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif

varying vec2 textureCoordinate;
uniform vec4 color;
uniform vec4 glassColor;
uniform float alpha;
uniform float sharpness;
uniform float strokeSize;

void main()
{
    float solidArea = strokeSize * sharpness;
    float d = distance(textureCoordinate, vec2(0.5, 0.5));
    if (d <= solidArea) {
        gl_FragColor = vec4(color.rgb, alpha);
    } else if (d <= strokeSize) {
        float strength = (d - strokeSize) / (solidArea - strokeSize);
        vec4 hintColor = mix(glassColor, color, strength);
        gl_FragColor = vec4(hintColor.rgb, alpha * hintColor.a);
    } else {
        gl_FragColor = glassColor;
    }
}
