#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D u_texture;
uniform vec4 vColor;
uniform float uAlpha;

uniform sampler2D strokeMaskTexture;
uniform int strokeMode;
uniform vec4 strokeHighlightColor;

void main()
{
    if (vColor.r == 0.0 && vColor.g == 0.0 && vColor.b == 0.0 && vColor.a == 0.0) {
        vec4 color = texture2D(u_texture, textureCoordinate);
        vec4 s = texture2D(strokeMaskTexture, textureCoordinate);
        if (strokeMode == 1) { // MODE_ERASER
            color.a *= s.a;
        } else if (strokeMode == 3) { // MODE_CUTOUT
            color.a *= (1.0 - s.a);
        } else if (strokeMode == 5) { // MODE_CUTOUT_HIGHLIGHT
            color = vec4(mix(strokeHighlightColor, color, s.a / 2.0 + 0.5).rgb, color.a);
        } else if (strokeMode == 6) { // MODE_ERASER_HIGHLIGHT
            color = vec4(mix(strokeHighlightColor, color, (1.0 - s.a * strokeHighlightColor.a) / 2.0 + 0.5).rgb, color.a * s.a);
        } else if (strokeMode == 8) { // For Effect apply, use source alpha
            color.a = s.a;
        }
        color.a *= uAlpha;
        gl_FragColor = color;
    } else {
        gl_FragColor = vColor;
    }
}
